/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2021 Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.datamanagement.shared.app.model;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;

import de.fhg.iese.dd.platform.datamanagement.framework.model.BaseEntity;
import de.fhg.iese.dd.platform.datamanagement.participants.tenant.model.Tenant;
import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.SuperBuilder;

@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor(access = AccessLevel.PROTECTED)
@SuperBuilder
public class AppVariantTenantContract extends BaseEntity {

    @ManyToOne(optional = false)
    private AppVariant appVariant;

    @ManyToOne(optional = false)
    private Tenant tenant;

    @Column
    private String notes;

    @Column(length = BaseEntity.MAXIMAL_TEXT_LENGTH)
    private String additionalNotes;

    private transient Set<AppVariantGeoAreaMapping> mappings;

    /**
     * This can only be used for autogenerated contracts, where only <strong>ONE</strong> exists per app variant and
     * tenant.
     */
    public AppVariantTenantContract withAutogeneratedId() {
        super.generateConstantId(appVariant, tenant);
        return this;
    }

    /**
     * Generates the id based on the data init id and the app variant
     */
    public AppVariantTenantContract withConstantId(String dataInitId) {
        //intentionally causing NPE if app variant is null
        super.generateConstantId(dataInitId, appVariant.getId());
        return this;
    }

    public AppVariantTenantContract withMappings(Set<AppVariantGeoAreaMapping> mappings) {
        this.mappings = mappings;
        return this;
    }

}
